
/* enemies */

initEnemies:
	//reset all sprites
	jsr resetSprites
	//disable all enemies
	lda #00; sta enemies+6*0; sta enemies+6*1; sta enemies+6*2; sta enemies+6*3; sta enemies+6*4; sta enemies+6*5; sta enemyFrame
	sta sprite2Y
	//set enemies pointer to start of the list
	lda #<enemies; sta enemyPointer; lda #>enemies; sta enemyPointer+1
	

	
	rts

enemies:
	//enabled x-pixel,y-cell,move-Dir,moveCount,x-cell
	.byte 0,0,0,DIR_LEFT,0,0
	.byte 0,0,0,DIR_RIGHT,0,0
	.byte 0,0,0,DIR_LEFT,0,0
	.byte 0,0,0,DIR_RIGHT,0,0
	.byte 0,0,0,DIR_LEFT,0,0
	.byte 0,0,0,DIR_LEFT,0,0
	
//move enemies
doEnemies:
	lda #<enemies; sta enemyPointer; lda #>enemies; sta enemyPointer+1
	//step from every enabled enemy
	//when we meet first disabled enemy it means no more enemies in list
	lda enemies+6*0; cmp #00; bne de1; rts			
de1:
	//inc move count	
	inc enemies+6*0+4; lda enemies+6*0+4; and #%00000111; sta enemies+6*0+4
	ldx enemies+6*0+1; ldy enemies+6*0+2
	jsr doOneEnemy 		
	
	//rts
	
	lda enemies+6*1; cmp #00; bne de2; rts			
de2:	
	inc enemies+6*1+4; lda enemies+6*1+4; and #%00000111; sta enemies+6*1+4
	ldx enemies+6*1+1; ldy enemies+6*1+2
	jsr doOneEnemy 	
	
	
		
	lda enemies+6*2; cmp #00; bne de3; rts			
de3:	
	inc enemies+6*2+4; lda enemies+6*2+4; and #%00000111; sta enemies+6*2+4
	ldx enemies+6*2+1; ldy enemies+6*2+2
	jsr doOneEnemy 	
		
	
	lda enemies+6*3; cmp #00; bne de4; rts			
de4:	
	inc enemies+6*3+4; lda enemies+6*3+4; and #%00000111; sta enemies+6*3+4
	ldx enemies+6*3+1; ldy enemies+6*3+2
	jsr doOneEnemy 	
		
	
	lda enemies+6*4; cmp #00; bne de5; rts			
de5:
	inc enemies+6*4+4; lda enemies+6*4+4; and #%00000111; sta enemies+6*4+4	
	ldx enemies+6*4+1; ldy enemies+6*4+2
	jsr doOneEnemy 	
	
	lda enemies+6*5; cmp #00; bne de6; rts			
de6:
	inc enemies+6*5+4; lda enemies+6*5+4; and #%00000111; sta enemies+6*5+4	
	ldx enemies+6*5+1; ldy enemies+6*5+2
	jsr doOneEnemy 		
				
	rts
	
doOneEnemy:
	
	//check hero collisions
	//x - pixel coord y-cell coord
	pha
	
	cpy heroY
	bne skipHeroCheck
	stx tmpVar
	//pixel hero x
	lda heroX; clc; adc #17; asl; asl; asl; sec; sbc #05
	sbc tmpVar
	
	bcs doe7
	eor #$ff		
	adc #01
doe7:
	cmp #09
	bcs	skipHeroCheck
	jsr killHero
	//:SetBorderColor(5)
skipHeroCheck:

	pla
	//in a - move count
	cmp #00
	bne doeNotCheck
	
	//ok check tile in new position based on dir and swap dir
	ldy #03; lda (enemyPointer),y
	cmp #DIR_LEFT
	bne checkRight
//check left tile
	//get x-cel coords
	ldy #05; lda (enemyPointer),y
	tax; dex
	cpx #01; bcc switchEnemyRight //limits	
	//check tile under
	ldy #02; lda (enemyPointer),y //get y
	tay; dex
	jsr getTile
	//not hit trail
	cmp #49
	bcs cntLeft
	cmp #TILE_SOLID
	bcs switchEnemyRight
cntLeft:	
	inx
	//save new cell coord	
	ldy #05; txa; sta (enemyPointer),y			
	jmp endOfCheck
	
switchEnemyRight:	
	ldy #03; lda #DIR_RIGHT; sta (enemyPointer),y
	jmp endOfCheck
checkRight:	
//get x coords back to cell
	ldy #05; lda (enemyPointer),y
	tax; inx	
	cpx #12; bcs switchEnemyLeft //limits	
	//check tile under
	ldy #02; lda (enemyPointer),y //get y
	tay// inx
	jsr getTile
	cmp #49
	bcs cntRight
	cmp #TILE_SOLID
	bcs switchEnemyLeft
cntRight:
	//dex
	
	
	ldy #05; txa; sta (enemyPointer),y
	jmp endOfCheck
switchEnemyLeft:	
	ldy #03; lda #DIR_LEFT; sta (enemyPointer),y

endOfCheck:
	
doeNotCheck:
	
//Move according to direction
	//get dir
	ldy #03; lda (enemyPointer),y
	cmp #DIR_LEFT
	bne doeRight
	//dec x coord
	ldy #01; lda (enemyPointer),y; tax; dex; txa; sta (enemyPointer),y		
	jmp doeEnd
doeRight:	
	
//inc x coord
	ldy #01; lda (enemyPointer),y; tax; inx; txa; sta (enemyPointer),y		
doeEnd:


	//step pointer plus 6
	lda enemyPointer; clc; adc #06; sta enemyPointer; lda enemyPointer+1; adc #0; sta enemyPointer+1	
	
	
	rts	
	
//fix sprites inside a camera
doEnemiesSprites:	
	//hide sprite
	jsr resetSprites
	//Set sprites pointer to start
	lda #<enemiesSprites; sta enemySpritePointer; lda #>enemiesSprites; sta enemySpritePointer+1	
	//step from every enabled enemy and attach sprite
	//whn we meet first disabled enemy it means no more enemies in list
	lda enemies+6*0; cmp #00; bne des1; rts		
des1:
	//load coords of enemy and fix sprite inside camera
	ldx enemies+6*0+1; ldy enemies+6*0+2; jsr doOneEnemySprite	
	
	
	lda enemies+6*1; cmp #00; bne des2; rts		
des2:
	//load coords of enemy and fix sprite inside camera
	ldx enemies+6*1+1; ldy enemies+6*1+2; jsr doOneEnemySprite	
	
	
	lda enemies+6*2; cmp #00; bne des3; rts		
des3:
	//load coords of enemy and fix sprite inside camera
	ldx enemies+6*2+1; ldy enemies+6*2+2; jsr doOneEnemySprite	
	
	lda enemies+6*3; cmp #00; bne des4; rts		
des4:
	//load coords of enemy and fix sprite inside camera
	ldx enemies+6*3+1; ldy enemies+6*3+2; jsr doOneEnemySprite		
	
	lda enemies+6*4; cmp #00; bne des5; rts		
des5:
	//load coords of enemy and fix sprite inside camera
	ldx enemies+6*4+1; ldy enemies+6*4+2; jsr doOneEnemySprite		
	
	lda enemies+6*5; cmp #00; bne des6; rts		
des6:
	//load coords of enemy and fix sprite inside camera
	ldx enemies+6*5+1; ldy enemies+6*5+2; jsr doOneEnemySprite		

	rts
	
doOneEnemySprite:	
	//sprites are hiden by default
	
	//lda heroPreY		
	tya //put y to ac
	sec
	sbc cameraY			
does1:
	cmp #25
	bcs does2
	//ok <24 we need to put hero sprite
	ldy #01 //point to y
	asl; asl; asl; clc; adc #43; clc; adc yScroll	
	
	cmp #248
	bcs does2//more 200
	cmp #48//less 48
	bcc does2

	sta (enemySpritePointer),y		
	
	ldy #00//point to x
	txa; sta (enemySpritePointer),y
	//step pointer plus 3
	lda enemySpritePointer; clc; adc #03; sta enemySpritePointer; lda enemySpritePointer+1; adc #0; sta enemySpritePointer+1		
	rts	
does2:
	
	rts	

//x - x cell y - ycell			
//a-direction
addEnemy:	
	sta enemyDirection+1	
	tya; pha //save y	
	lda enemyDirection+1
//============stupid fix=====	
	cmp #DIR_RIGHT
	bne notFixAD
	inx
	ldy #05
	txa; sta (enemyPointer),y//save x-cell
	dex
	jmp endFixes
notFixAD:	
	ldy #05
	txa; sta (enemyPointer),y//save x-cell
endFixes:	
//============stupid fix=====
	pla //tay
	
	//tya//save y cell
	
	ldy #02
	sta (enemyPointer),y//save y
	//ldy #05
	txa //sta (enemyPointer),y//save x-cell
	ldy #01
	clc; adc #17; asl; asl; asl; sec; sbc #05
	sta (enemyPointer),y//save x
	ldy #00
	lda #01
	sta (enemyPointer),y//enable
	ldy #04; lda #00
	sta (enemyPointer),y//movecount
	ldy #03 
enemyDirection:	lda #DIR_RIGHT
	sta (enemyPointer),y//dir

	//step enemy pointer by 6
	lda enemyPointer; clc; adc #06; sta enemyPointer; lda enemyPointer+1; adc #0;	sta enemyPointer+1		
	
	rts

resetSprites:
	//put base values to virtual sprites
	lda #255; sta enemiesSprites+3*0+1
	sta enemiesSprites+3*1+1
	sta enemiesSprites+3*2+1
	sta enemiesSprites+3*3+1
	sta enemiesSprites+3*4+1
	sta enemiesSprites+3*5+1
	sta sprite2Y
	rts
	
//virtual enemies sprites multiplexed over a screen
enemiesSprites:
//x, y - pixel
// frame
	.byte 64+4*0,255,0
	.byte 64+4*1,255,0
	.byte 64+4*2,255,0
	.byte 64+4*3,255,0
	.byte 64+4*4,255,0
	.byte 64+4*5,255,0
//first irq in a row
	
endChain0:
	lda #mainIrqLine; sta $d012
	lda #<mainIrq; sta $fffe; lda #>mainIrq; sta $ffff
	lsr $d019 //for correct exit from irq	
	pla
	rti	
	
//enemy1	
irq1:
	pha 
	//apply coords of enemy 1
	lda enemiesSprites; sta sprite2X; lda enemiesSprites+1; sta sprite2Y;	lda enemiesSprites+2; clc; adc #144+18; sta sprite2
	//lda #128+18 sta sprite2 lda #1 sta sprite2Color
	//next line for interrupt - before a sprite
	lda enemiesSprites+3*1+1 
	cmp #255
	beq endChain0
	//next irq	
	sec; sbc #2; sta $d012	
	lda #<irq2; sta $fffe; lda #>irq2; sta $ffff
	
	lsr $d019 //for correct exit from irq
	pla	
	rti
	
irq2:	
	pha 
	//apply coords of enemy 1
	lda enemiesSprites+3*1; sta sprite2X; lda enemiesSprites+3*1+1; sta sprite2Y;	lda enemiesSprites+3*1+2; clc; adc #144+18; sta sprite2
	//lda #128+18 sta sprite2 lda #1 sta sprite2Color
	//next line for interrupt - before a sprite
	lda enemiesSprites+3*2+1 
	cmp #255
	beq endChain0
	//next irq	
	sec; sbc #2; sta $d012	
	lda #<irq3; sta $fffe; lda #>irq3; sta $ffff
	
	lsr $d019 //for correct exit from irq
	pla	
	rti
	

irq3:	
	pha 
	//apply coords of enemy 1
	lda enemiesSprites+3*2; sta sprite2X; lda enemiesSprites+3*2+1; sta sprite2Y;	lda enemiesSprites+3*2+2; clc; adc #144+18; sta sprite2
	//lda #128+18 sta sprite2 lda #3 sta sprite2Color
	//next line for interrupt
	lda enemiesSprites+3*3+1 
	cmp #255
	beq endChain
	sec; sbc #2; sta $d012
	//next irq
	lda #<irq4; sta $fffe; lda #>irq4; sta $ffff
	lsr $d019 //for correct exit from irq
	pla
	rti	

		
irq4:	
	pha 
	//apply coords of enemy 1
	lda enemiesSprites+3*3; sta sprite2X; lda enemiesSprites+3*3+1; sta sprite2Y;	lda enemiesSprites+3*3+2; clc; adc #144+18; sta sprite2
	//lda #128+18 sta sprite2 lda #4 sta sprite2Color
	//next line for interrupt
	lda enemiesSprites+3*4+1 
	cmp #255
	beq endChain
	sec; sbc #2;  sta $d012
	//next irq
	lda #<irq5; sta $fffe; lda #>irq5; sta $ffff	
	lsr $d019 //for correct exit from irq
	pla
	rti	

endChain:
	lda #mainIrqLine; sta $d012
	lda #<mainIrq; sta $fffe; lda #>mainIrq; sta $ffff
	lsr $d019 //for correct exit from irq	
	pla
	rti		
		
irq5:	
	pha 
	//apply coords of enemy 1
	lda enemiesSprites+3*4; sta sprite2X; lda enemiesSprites+3*4+1; sta sprite2Y;	lda enemiesSprites+3*4+2; clc; adc #144+18; sta sprite2
	//lda #128+18 sta sprite2 lda #4 sta sprite2Color
	//next line for interrupt
	lda enemiesSprites+3*5+1 
	cmp #255
	beq endChain
	sec; sbc #2;  sta $d012
	//next irq
	lda #<irq6; sta $fffe; lda #>irq6; sta $ffff	
	lsr $d019 //for correct exit from irq
	pla
	rti		
	
irq6:	
	pha 
	//apply coords of enemy 1	
	lda enemiesSprites+3*5
	cmp #255
	beq endChain
	sta sprite2X; lda enemiesSprites+3*5+1; sta sprite2Y;	lda enemiesSprites+3*5+2; clc; adc #144+18; sta sprite2	
	jmp endChain
	//next line for interrupt is main interrupt on zero
	//lda #250 sta $d012
	//next irq
	//lda #<mainIrq sta $fffe lda #>mainIrq sta $ffff			
	//lsr $d019 //for correct exit from irq	
	//pla
	//rti		
	
irq0:
	pha 
			
		
    stx xz0+1
    sty yz0+1
	
    jsr doStars	
	jsr $e003
	jsr doSky		

	
	
xz0: ldx #$00
yz0: ldy #$00	
	

			
	lda enemiesSprites+3*0+1
	cmp #255
	beq endChain
	sec; sbc #2;  sta $d012
	lda #<irq1; sta $fffe; lda #>irq1; sta $ffff	
	lsr $d019 //for correct exit from irq		
	
	pla
	
	rti
	
mainIrq:
	
	sta atemp+1
    stx xtemp+1
    sty ytemp+1
    
    lda $d011
	and #%11111000 //low 3 bits
	clc
	adc yScroll
	sta $d011
	
	/*
	lda $d016
	and #%11111000
	clc
	adc xScroll
	sta $d016
	*/
	
    //jsr processCamera
	jsr doEnemiesSprites
	jsr doHeroSprite
	lda clearCount
	cmp #32
	beq skopa
	jsr fixSpriteFX
	lda fxFrame; sta sprite1; lda fxSpriteX; sta sprite1X; lda fxSpriteY; sta sprite1Y
skopa:
	
	//jsr doSky
	//jsr doFX	
	
	
//	:SetBorderColor(3)
//	inc $d020
//	:SetBorderColor(0)
	//
	//next irq
	lda #10; sta $d012
	lda #<irq0; sta $fffe; lda #>irq0; sta $ffff	
	
	//set frame ready flag
	//lda #255 sta frameReady	
	lsr $d019 //for correct exit from irq	
	
atemp: lda #$00
xtemp: ldx #$00
ytemp: ldy #$00
	
	rti
