/* GUNS */

//guns count is global 256/8

gunsCount: .byte 0

initGuns:

	//init ppointers
	lda #<gunsList ; sta gunsPointer ; lda #>gunsList ; sta gunsPointer+1

	//init count
	lda #10 		
	sta gunsCount
	
	//clear list
	lda #0 ; ldx #0
iGuns:
	sta gunsList,x ; inx
	cpx #4*8
	bne iGuns	
	
	rts
	
resetGuns:
	lda #<gunsList ; sta gunsPointer ; lda #>gunsList ; sta gunsPointer+1
	rts

gunsList:
	//enabled,x,y,DIRECTION
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0
	
//save here tiles under fire
gunsRestoreBuffer: .byte 0,0,0,0,0,0,0,0,0,0,0,0
	
//in a - count 0,1,2,3
processBeam: 
	//get coords	
	clc ; adc #TILE_BEAM
	sta fireTile
	ldy #01 ; lda (gunsPointer),y ; tax
	ldy #02 ; lda (gunsPointer),y ; sta py+1	    
	//direction
	ldy #03 ; lda (gunsPointer),y ; tay	    
	//pla
	
py:	ldy #00		
	cmp #DIR_RIGHT
	bne processLeft	
	jmp fireRight		
	rts
processLeft:	
	jmp fireLeft
	rts		

fireTile: .byte 0
	
fireRight:
	inx
	jsr getTileSafe	
	cmp #49
	bcs cntShoot
	cmp #TILE_SOLID
	bcs endShoot
	//save to restore buffer if less than solid		
	sta gunsRestoreBuffer,x
cntShoot:
	lda fireTile ; jsr putTileSafe	
	cpx #11
	bne fireRight
	
	rts

endShoot:
	rts	
		
fireLeft:	
	dex
	jsr getTileSafe	
	cmp #49
	bcs cntShoot2
	cmp #TILE_SOLID
	bcs endShoot
	//save to restore buffer if less than solid		
	sta gunsRestoreBuffer,x
cntShoot2:
	lda fireTile ; jsr putTileSafe	
	cpx #00
	bne fireLeft
	
	rts	
	
//////////////////////////////////////////////
processRestore:
	ldy #01 ; lda (gunsPointer),y ; tax
	ldy #02 ; lda (gunsPointer),y ; sta pr+1
	//direction
	ldy #03 ; lda (gunsPointer),y ; tay	    
pr:	ldy #00		
	cmp #DIR_RIGHT
	bne processRestoreLeft	
	jmp restoreRight		
	rts
processRestoreLeft:	
	jmp restoreLeft
	
	rts
		
restoreRight:
	inx

	jsr getTileSafe	
	cmp #49
	bcs cntRestore
	cmp #TILE_SOLID
	bcs endShoot
cntRestore:
	lda gunsRestoreBuffer,x
	jsr putTileSafe	
	cpx #11
	bne restoreRight
	
	rts

endRestore:
	rts	
		
restoreLeft:	
	dex
	
	jsr getTileSafe	
	cmp #49
	bcs cntRestoreLeft
	cmp #TILE_SOLID
	bcs endShoot
cntRestoreLeft:
	
	lda gunsRestoreBuffer,x	
	jsr putTileSafe	
	cpx #00
	bne restoreLeft
	
	rts	
	
//////////////////////////////////////////////
	
doRestore:
	jmp processRestore
	
doBeam:
	jmp processBeam
	
endFire:
//get direction
	ldy #03 ; lda (gunsPointer),y ; tay
	cmp #DIR_RIGHT
	bne efLeft	
	
	//get coords
	ldy #01 ; lda (gunsPointer),y ; tax
	ldy #02;  lda (gunsPointer),y ; tay	
	lda #TILE_GUNRIGHT; 	jsr putTile	
	lda gunsPointer ;  clc ; adc #04 ; sta gunsPointer ; lda gunsPointer+1 ; adc #0 ; sta gunsPointer+1		
	rts
efLeft:	
//get coords
	ldy #01 ; lda (gunsPointer),y ; tax
	ldy #02 ; lda (gunsPointer),y ; tay	
	lda #TILE_GUNLEFT ; jsr putTile	
	lda gunsPointer ; clc ; adc #04 ; sta gunsPointer ; lda gunsPointer+1 ; adc #0 ; sta gunsPointer+1	
	rts		
	
doGuns:	
	//check if no guns just rts
	lda gunsList
	bne doDatGuns
	rts
doDatGuns:

	inc gunsCount
	lda gunsCount
	//every 64 tick
tickMask:	and #%00111111	
	sta gunsCount
	cmp #8
	bcc doBeam
tickMax:	cmp #63
	beq fireGun		
	cmp #08
	beq doRestore
	cmp #09
	beq endFire
	rts
fireGun:
	// is it enable
	ldy #00 ; lda (gunsPointer),y
	cmp #00
	bne gunEnabled
	//if not enabled - reset to first
	jsr resetGuns
gunEnabled:
//fire
	lda #2 ; jsr playSound
	
	
	//get direction
	ldy #03 ; lda (gunsPointer),y ; tay
	cmp #DIR_RIGHT
	bne fgLeft	
	
	//get coords
	ldy #01 ; lda (gunsPointer),y ; tax
	ldy #02 ; lda (gunsPointer),y ; tay	
	lda #TILE_GUNRIGHT-2	; jsr putTile
	
	//lda gunsPointer clc adc #04 sta gunsPointer lda gunsPointer+1 adc #0 sta gunsPointer+1	
	
	rts
fgLeft:	

//get coords
	ldy #01 ; lda (gunsPointer),y ; tax
	ldy #02 ; lda (gunsPointer),y ; tay
	
	lda #TILE_GUNLEFT-2	; jsr putTile
	
	//lda gunsPointer clc adc #04 sta gunsPointer lda gunsPointer+1 adc #0 sta gunsPointer+1	
	rts	

	
//x - x cell y - ycell			
//a-direction	
addGun:	
	//save direction	
	pha
	//save y
	tya ; ldy #02 ; sta (gunsPointer),y
	//save x
	txa ; ldy #01;  sta (gunsPointer),y	
	//restore direction
 	pla
 	ldy #03 ;  sta (gunsPointer),y	
	//enable
	lda #01 ; ldy #00 ; sta (gunsPointer),y
	//step guns pointer
	lda gunsPointer ; clc ; adc #04 ; sta gunsPointer ; lda gunsPointer+1 ; adc #0 ; sta gunsPointer+1	
	rts