/* show intro hi res picture */

showIntroText:

	jsr initIntroTextIRQ
	lda #00 //zero to a
	sta $d020 //black border
	sta $d021 //black background
	jsr showScreen
	jsr clearScreen0
.var ystart = 6	
	lda #<screen+40*(ystart-1)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart-1)+1 ; sta stringAddress+2
	lda #<introText ; sta stringPointer+1 ; lda #>introText ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+2)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+2)+1 ; sta stringAddress+2
	lda #<introText1 ; sta stringPointer+1 ; lda #>introText1 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+3)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+3)+1 ; sta stringAddress+2
	lda #<introText2 ; sta stringPointer+1 ; lda #>introText2 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+4)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+4)+1 ; sta stringAddress+2
	lda #<introText3 ; sta stringPointer+1 ; lda #>introText3 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+5)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+5)+1 ; sta stringAddress+2
	lda #<introText4 ; sta stringPointer+1 ; lda #>introText4 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+7)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+7)+1 ; sta stringAddress+2
	lda #<introText5 ; sta stringPointer+1 ; lda #>introText5 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+8)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+8)+1 ; sta stringAddress+2
	lda #<introText6 ; sta stringPointer+1 ; lda #>introText6 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+11)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+11)+1 ; sta stringAddress+2
	lda #<introText8 ; sta stringPointer+1 ; lda #>introText8 ; sta stringPointer+2
	jsr drawString
	
	lda #<screen+40*(ystart+12)+1 ; sta stringAddress+1 ; lda #>screen+40*(ystart+12)+1 ; sta stringAddress+2
	lda #<introText7 ; sta stringPointer+1 ; lda #>introText7 ; sta stringPointer+2
	jsr drawString
	
	//jmp *
	
	
	ldx #235; jsr pauseWait	
	ldx #235; jsr pauseWait
	jsr hideScreen
	ldx #10 ; jsr pauseWait	
	
	rts
	
drawString:
	ldx #00
stringPointer:	lda introText,x
	cmp #255
	beq endString	
stringAddress:	sta 1024,x
	inx
	jmp stringPointer
endString:
	rts
		
//255 - end of string	
introText: .text "old tower" ; .byte 255
introText1: .text "game by denis grachev" ; .byte 255
introText2: .text "music by oleg nikitin" ; .byte 255
introText3: .text "pixels by ivan seleznev" ; .byte 255
introText4: .text "thanks to artem vasilyev" ; .byte 255
introText5: .text "inspired by tomb of the mask" ; .byte 255
introText6: .text "from playgendary" ; .byte 255
introText7: .text "retrosouls team 2018-2020" ; .byte 255
introText8: .text "www.retrosouls.net" ; .byte 255


//#$01: 262 rasterlines and 64 cycles per line [NTSC: 6567R56A VIC] (OLD NTSC) 
//#$02: 263 rasterlines and 65 cycles per line [NTSC: 6567R8 VIC]
//#$03: 312 rasterlines and 63 cycles per line [PAL: 6569 VIC]
//#$04: 312 rasterlines and 65 cycles per line [Drean PAL-N: 6572 VIC] 
commodoreModel: .byte 0

detectModel:
 //	sei
    ldx #$00
w0:  lda $D012
w1:  cmp $D012
    beq w1
    bmi w0
    and #$03
    cmp #$03
    bne detectionDone //; done for NTSC
    tay
countCycles:
    inx
    lda $D012
    bpl countCycles
    cpx #$5E  //; VICE values: PAL-N=$6C PAL=$50
	      		//; so choose middle value $5E for check 
    bcc isPAL
    iny// ; is PAL-N
isPAL:
    tya
detectionDone:	
	sta commodoreModel
	rts

showIntro:
	//unpack picture to 49152 #c000
	jsr detectModel
	
	//sei //turn off interupts
 
//colors init
	lda #00 //zero to a
	sta $d020 //black border
	sta $d021 //black background
	
//    lda #%00011000        
//    sta $d018  

	//enable hires mode	

  	//cli //turn on
  	
	
//.var unpackPic = 49152+8192	
//.var unpackColors = 49152

	jsr hideScreen
	
	
	lda commodoreModel
	cmp #03
	bcs unpackPal
	lda #<musicPackedNTSC ; sta lzsa_src+1 ; lda #>musicPackedNTSC ; sta lzsa_src+2
	jmp endUnpack
unpackPal:	
	//depack music based on NTSC|PAL
	lda #<musicPacked ; sta lzsa_src+1 ; lda #>musicPacked ; sta lzsa_src+2
endUnpack:	
	//jsr detectModel	
	
	lda #<music ; sta lzsa_dst+1 ; lda #>music ; sta lzsa_dst+2
	jsr decompress_lzsa1_fast
	
	lda #0 ; jsr $e000                       //Initialize subtune 0 	
	
	
	jsr initIntroIRQ
	jsr hideScreen
	
	 ldx #0
loop:
    lda $7f40,x
    sta $5c00,x
    lda $8040,x
    sta $5d00,x
    lda $8140,x
    sta $5e00,x
    lda $8240,x
    sta $5f00,x

    lda $8328,x
    sta $d800,x
    lda $8428,x
    sta $d900,x
    lda $8528,x
    sta $da00,x
    lda $8628,x
    sta $db00,x

    inx
    bne loop

    lda $8710     // get background color
    sta $d020
    sta $d021
    //jmp *
	
	
	/*
	//jsr hideScreen
  	
	//fix color ram
//	lda picBG ; sta $d020 ; sta $d0211
	ldx #0
refixColor:	
	//lda #%00010001 sta 32768,x
	lda 16384+8192-2048,x ; sta colorRam,x
	lda 16384+8192-2048+200*1,x ; sta colorRam+200*1,x
	lda 16384+8192-2048+200*2,x ; sta colorRam+200*1,x
	lda 16384+8192-2048+200*3,x ; sta colorRam+200*1,x
	lda 16384+8192-2048+200*4,x ; sta colorRam+200*4,x
	

	inx
	cpx #200
	bne refixColor
	*/
	
//lzsa_dst+1 - where unpack
//lzsa_src+1 - from
	/*
	lda #<introPixels sta lzsa_src+1 lda #>introPixels sta lzsa_src+2	
	lda #<unpackPic sta lzsa_dst+1 lda #>unpackPic sta lzsa_dst+2
	jsr decompress_lzsa1_fast
	
	lda #<introColors sta lzsa_src+1 lda #>introColors sta lzsa_src+2	
	lda #<unpackColors sta lzsa_dst+1 lda #>unpackColors sta lzsa_dst+2
	jsr decompress_lzsa1_fast
	*/
	
	//fix color ram
	/*
	ldx #0
refixColor:	
	//lda #%00010001 sta 32768,x
	lda 32768+8192+8000,x sta 32768+7168,x
	lda 32768+8192+8000+200*1,x sta 32768+7168+200*1,x
	lda 32768+8192+8000+200*2,x sta 32768+7168+200*2,x
	lda 32768+8192+8000+200*3,x sta 32768+7168+200*3,x
	lda 32768+8192+8000+200*4,x sta 32768+7168+200*4,x
	inx
	cpx #200
	bne refixColor
	*/
	
	jsr showScreen

	
	ldx #235; jsr pauseWait	
	ldx #235; jsr pauseWait
	jsr hideScreen
	ldx #10 ; jsr pauseWait
	
	//jsr hideScreen
	
//vvv:
//	jsr waitScanlineEx //wait for scanline
//	dec $d020
//	jmp vvv	
	
	rts
	
introIrq:
	stx stackX ; sty stackY
	pha
	jsr $e003                       //Initialize subtune 0 	
	lsr $d019 //for correct exit from irq	
	ldx stackX ; ldy stackY
	pla
	
	//dec $d020
	rti
	
introTextIrq:
	lsr $d019 //for correct exit from irq	
	//dec $d020
	rti	
