
/*
Level is array 12*64
Visible zone is 12*24


*/


//starsLo:	.byte <screen+14*40+6
//starsHi:	.byte >screen+14*40+6
//starsLo:	.byte <colorRam+14*40+6
//starsHi:	.byte >colorRam+14*40+6


setStartPoint:

	lda #<level+12*39 //low byte screen start
	sta levelStart //save low byte
	lda #>level+12*39 //high byte screen start
	sta levelStart+1 //hi byte save		

	lda #39; sta cameraY

	rts

drawStars:

	lda #totalTiles; sta screen+0*40+1; lda #totalTiles+1; sta screen+1*40+1; lda #totalTiles+2; sta screen+2*40+1; lda #totalTiles+3; sta screen+3*40+1
	lda #totalTiles; sta screen+4*40+6; lda #totalTiles+1; sta screen+5*40+6; lda #totalTiles+2; sta screen+6*40+6; lda #totalTiles+3; sta screen+7*40+6		
	lda #totalTiles; sta screen+9*40+10; lda #totalTiles+1; sta screen+10*40+10; lda #totalTiles+2; sta screen+11*40+10;	lda #totalTiles+3; sta screen+12*40+10
	lda #totalTiles; sta screen+12*40+2; lda #totalTiles+1; sta screen+13*40+2; lda #totalTiles+2; sta screen+14*40+2;	lda #totalTiles+3; sta screen+15*40+2
	lda #totalTiles; sta screen+14*40+8; lda #totalTiles+1; sta screen+15*40+8; lda #totalTiles+2; sta screen+16*40+8; lda #totalTiles+3; sta screen+17*40+8
	
	
	lda #totalTiles; sta screen+0*40+38; lda #totalTiles+1; sta screen+1*40+38; lda #totalTiles+2; sta screen+2*40+38;  lda #totalTiles+3; sta screen+3*40+38
	lda #totalTiles; sta screen+2*40+28; lda #totalTiles+1; sta screen+3*40+28; lda #totalTiles+2; sta screen+4*40+28;  lda #totalTiles+3; sta screen+5*40+28
	
	lda #totalTiles; sta screen+5*40+33; lda #totalTiles+1; sta screen+6*40+33; lda #totalTiles+2; sta screen+7*40+33;  lda #totalTiles+3; sta screen+8*40+33
	
	lda #totalTiles; sta screen+11*40+29; lda #totalTiles+1; sta screen+12*40+29; lda #totalTiles+2; sta screen+13*40+29;  lda #totalTiles+3; sta screen+14*40+29
	
	lda #totalTiles; sta screen+13*40+37; lda #totalTiles+1; sta screen+14*40+37; lda #totalTiles+2; sta screen+15*40+37;  lda #totalTiles+3; sta screen+16*40+37
	
	
	rts

musicWin:
	lda #0 ; sta currentMusic ; jsr $e000                       //Initialize subtune 0 	
	ldx #4 ; jsr pauseWait	
	rts	
	
initMusic:
	
	lda currentLevel	
	
	cmp #21
	bcs musicWin
	
	cmp #16
	bcs music2
	
	cmp #11
	bcs music1
	
	cmp #6
	bcs music2	
	
	rts	
music2:
	lda currentMusic
	cmp #2
	bne playMusic2	
	rts
music1:
	lda currentMusic
	cmp #1
	bne playMusic1
	rts	
	
playMusic2:
	lda #2 ; sta currentMusic ; jsr $e000                       //Initialize subtune 0 	
	ldx #4 ; jsr pauseWait	
	rts
playMusic1:
	lda #1 ; sta currentMusic ; jsr $e000                       //Initialize subtune 0 		
	ldx #4 ; jsr pauseWait
	rts	
	
initWorld:	
	jsr initMusic

	//WORLD#1
	lda #02
 	sta $d022 //mc1 	 	
	lda #06
 	sta $d023 //mc2
 	
 	lda #01; sta sprite2Color
 	
 	//guns period setup
 	lda #%00111111;	sta tickMask+1; lda #63; sta tickMax+1
 	
	lda currentLevel
	
	cmp #16
	bcs setWorld3
	
	cmp #11
	bcs setWorld2	
	
	rts
setWorld2: 	
	lda #07; sta sprite2Color
	lda #%00111111;	sta tickMask+1; lda #63; sta tickMax+1
 	//WORLD#2
	lda #01
 	sta $d022 //mc1 	 	
	lda #06
 	sta $d023 //mc2
 	jsr copyTiles02
 	
 	rts
setWorld3: 	
	lda #05; sta sprite2Color //or 3
	lda #%00011111;	sta tickMask+1; lda #31; sta tickMax+1
 	//WORLD#3
	lda #07
 	sta $d022 //mc1 	 	
	lda #06
 	sta $d023 //mc2
 	jsr copyTiles03 	
 	rts

copyTiles02:
	//tiles
	lda #<tiles02; sta from; lda #>tiles02; sta from+1
	lda #<tiles; sta to; lda #>tiles; sta to+1
	lda #<totalTiles*8; sta size; lda #>totalTiles*8; sta size+1
	jsr moveDown
	
	lda #<tilesColors02; sta from; lda #>tilesColors02; sta from+1
	lda #<tilesColors; sta to; lda #>tilesColors; sta to+1
	lda #<totalTiles; sta size; lda #>totalTiles; sta size+1
	jsr moveDown

	jsr drawTower
	
	rts
	
copyTiles03:
	//tiles
	lda #<tiles03; sta from; lda #>tiles03; sta from+1
	lda #<tiles; sta to; lda #>tiles; sta to+1
	lda #<totalTiles*8; sta size; lda #>totalTiles*8; sta size+1
	jsr moveDown
	
	lda #<tilesColors03; sta from; lda #>tilesColors03; sta from+1
	lda #<tilesColors; sta to; lda #>tilesColors; sta to+1
	lda #<totalTiles; sta size; lda #>totalTiles; sta size+1
	jsr moveDown

	jsr drawTower
	
	rts	
	
//; FROM = source start address
//;   TO = destination start address
//; SIZE = number of bytes to move
//;
moveDown: ldy #0
         ldx size+1
         beq md2
md1:      lda (from),y //; move a page at a time
         sta (to),y
         iny
         bne md1
         inc from+1
         inc to+1
         dex
         bne md1
md2:      ldx size
         beq md4
md3:      lda (from),y //; move the remaining bytes
         sta (to),y
         iny
         dex
         bne md3
md4:      rts
		
 	
initLevel:
	jsr waitScanline //wait for scanline	
	jsr hideScreen
	
	jsr initWorld
	
	//DRAW BOTTOM SKY
	//83 84

	lda #00; sta xScroll; sta clearCount
	jsr initGuns
	
	jsr unpackLevel	
	
	//init camera
	jsr initCamera
	
	jsr initSky
	jsr drawSky
	jsr drawStars

	//reset animations
	lda #vHeroAnimDelay //reset counter
	sta heroAnimDelay  //save it
	
	lda #vAnimDelay //reset counter
	sta animDelay  //save it	
	
	lda #0; sta totalCoins //reset total coins

//set levelStart buffer to draw
	lda #<level+12*0 //low byte screen start
	sta levelStart //save low byte
	lda #>level+12*0 //high byte screen start
	sta levelStart+1 //hi byte save		
	
	jsr initHero
	jsr initFX
	jsr initEnemies

	//set exit color to default
	lda #06; sta tilesColors+13
	
	
	jsr parseLevel
	//reset before start
	jsr resetGuns
	
	//ldx heroX ldy heroY lda #FX_REFLECT jsr spawnFX

	jsr setStartPoint
	
	jsr waitScanline //wait for scanline	
	//jsr showScreen
	
	rts

	
drawSky:
	
	ldx #00
reX:
	
	lda #82; sta screen+20*40,x; lda #04; sta colorRam+21*40,x
	lda #83; sta screen+21*40,x; lda #04; sta colorRam+22*40,x
	lda #84; sta screen+22*40,x; lda #04; sta colorRam+23*40,x
	lda #85; sta screen+23*40,x; lda #04; sta colorRam+24*40,x
	lda #86; sta screen+24*40,x; lda #04; sta colorRam+24*40,x
	
	//lda #85 sta screen+22*40+1,x lda #04 sta colorRam+22*40+1,x
	//lda #86 sta screen+23*40+1,x lda #04 sta colorRam+23*40+1,x
	//lda #87 sta screen+24*40+1,x lda #04 sta colorRam+24*40+1,x
	
	lda #82; sta screen+20*40+28,x; lda #04; sta colorRam+21*40+28,x
	lda #83; sta screen+21*40+28,x; lda #04; sta colorRam+22*40+28,x
	lda #84; sta screen+22*40+28,x; lda #04; sta colorRam+23*40+28,x
	lda #85; sta screen+23*40+28,x; lda #04; sta colorRam+24*40+28,x
	lda #86; sta screen+24*40+28,x; lda #04; sta colorRam+24*40+28,x
	
	//lda #85 sta screen+22*40+28+1,x lda #04 sta colorRam+22*40+28+1,x
	//lda #86 sta screen+23*40+28+1,x lda #04 sta colorRam+23*40+28+1,x
	//lda #87 sta screen+24*40+28+1,x lda #04 sta colorRam+24*40+28+1,x				
	inx
	cpx #12
	bne reX
	rts

drawTower:

 	
 	//set screen pointer to start screen
	lda #<screenStart-2 //low byte screen start
	sta screenPointer //save low byte
	lda #>screenStart-2 //high byte screen start
	sta screenPointer+1 //hi byte save
	
	//set color pointer to start screen
	lda #<colorStart-2 //low byte color start
	sta colorPointer //save low byte
	lda #>colorStart-2 //high byte color start
	sta colorPointer+1 //hi byte save
 		
	
	
		
	ldy #00
nextPart:
	
	lda #38
	jsr putTileToPointer		
	
	jsr stepPointers
	
	lda #37
	jsr putTileToPointer				
	
	lda #13
	sta delta
	jsr stepPointersDelta
	
	lda #35
	jsr putTileToPointer		
	
	jsr stepPointers
	lda #40
	jsr putTileToPointer	
	
	lda #40-16
	sta delta
	jsr stepPointersDelta	
	
	
 	iny
	cpy #25//end of lines
	bne nextPart
	
	rts

putTileToPointer:
	sta (screenPointer),y
	tax
	lda tilesColors,x
	sta (colorPointer),y
	rts
checkGuns:
	cmp #TILE_GUNRIGHT
	bne plNotGunRight
	tya; pha //save y
	lda #DIR_RIGHT
	//load cell coords
	ldx stackX; ldy stackY
	jsr addGun//add enemy
	pla; tay//restore y
	//save 0 to level
	lda #TILE_GUNRIGHT
	rts
plNotGunRight:	
	cmp #TILE_GUNLEFT
	bne plNotGunLeft
	tya; pha //save y
	lda #DIR_LEFT
	//load cell coords
	ldx stackX; ldy stackY
	jsr addGun//add enemy
	pla; tay//restore y
	//save 0 to level
	lda #TILE_GUNLEFT
plNotGunLeft:	
	rts	
	
checkEnemy:
	//is it enemys
	cmp #ENEMY_RIGHT
	bne plNotEnemyRight
	tya; pha //save y
	lda #DIR_RIGHT
	//load cell coords
	ldx stackX; ldy stackY
	jsr addEnemy//add enemy
	pla; tay//restore y
	//save 0 to level
	lda #0 	
plNotEnemyRight:	
	cmp #ENEMY_LEFT
	bne plNotEnemyLeft
	tya; pha //save y
	lda #DIR_LEFT	
	//load cell coords
	ldx stackX; ldy stackY
	jsr addEnemy//add enemy
	pla; tay//restore y
	//save 0 to level
	lda #0 	
plNotEnemyLeft:	
	rts	

checkHero2:
	//second hero points
	cmp #TILE_STARTUP
	bne nu
	pha; lda #144+0; sta hero2+5; pla
	//save hero coords
	jsr addHero2
nu:
	cmp #TILE_STARTDOWN
	bne nd
	pha; lda #144+4; sta hero2+5; pla
	jsr addHero2
nd:
	cmp #TILE_STARTLEFT
	bne nl
	pha; lda #144+12; sta hero2+5; pla
	//save hero coords
	jsr addHero2
nl:
	cmp #TILE_STARTRIGHT
	bne nr
	pha; lda #144+8; sta hero2+5; pla
	//save hero coords
	jsr addHero2
nr:
	rts	
addHero2:	
	pha; lda stackX; 	sta hero2; lda stackY; sta hero2+1; pla //lda #0//TILE_START
	inc heroesCount
	rts
parseLevel:

	//set level pointer
	lda #<level+12*0 //low byte screen start
	sta levelPointer //save low byte
	lda #>level+12*0 //high byte screen start
	sta levelPointer+1 //hi byte save	
	
	lda #<restoreBuffer;	sta restorePointer; lda #>restoreBuffer; sta restorePointer+1 //hi byte save	
	
	//set screen pointer to start screen
	lda #<screenStart //low byte screen start
	sta screenPointer //save low byte
	lda #>screenStart //high byte screen start
	sta screenPointer+1 //hi byte save
	
	//set color pointer to start screen
	lda #<colorStart //low byte color start
	sta colorPointer //save low byte
	lda #>colorStart //high byte color start
	sta colorPointer+1 //hi byte save

	ldy #00 //lines count
new_line_loop:
	
	sty stackY //save lines count
	
	ldx #00 //total tiles count in a line
one_line_loop:
	ldy #0 //reset y		
	stx stackX //save x
		
	lda (levelPointer),y //get character (grab from level pointer)
	
	//save all
	sty stack2Y
	stx stack2X
	
//============ PARSE ===============
	jsr checkEnemy
	jsr checkHero2
	jsr checkGuns
	//hero start point
	cmp #TILE_START
	bne plNotHeroStart
	//save hero coords
	lda stackX; sta heroX; lda stackY; sta heroY; lda #0//TILE_START
	inc heroesCount
plNotHeroStart:
		
//inc coins counter
	cmp #TILE_COIN
	bne plNotCoin
	inc totalCoins
plNotCoin:
	cmp #TILE_GOLD
	bne plNotGold
	inc totalCoins
plNotGold:
	
	//replace in level
	sta (levelPointer),y
	
	//and put to restore buffer if not collectable item
	cmp #TILE_HIDDEN
	bne skipHidden
	lda #TILE_BLOCK	
skipHidden:

	cmp #TILE_GOLD
	beq skipoka
	cmp #TILE_CRACK
	beq skipoka
	cmp #TILE_COIN
	beq skipoka
	jmp skipoka2
skipoka:
	lda #0 
skipoka2:

	sta (restorePointer),y

//===========================================	
	//restore all	
	ldx stack2X
	ldy stack2Y
		
	//lda #29
	
	//sta (screenPointer),y //put it to screen
	//get color
	//tax //transfer to x
	//lda tilesColors,x //get tile RAM color to a
	//put it on screen
	//sta (colorPointer),y
	
	//next one - step all pointers forward
	jsr stepPointers
	//restore x
	ldx stackX
	
	inx //dec x
	cpx #12 //end of line
    bne one_line_loop //new one
    
	//step pointer line down
	jsr stepPointersDown
	//restory y
	ldy stackY
	iny
	cpy #63//end of lines
	bne new_line_loop

	rts
		
	
stepPointers:

//so restore pointer
	lda restorePointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 30 to ac-r
	sta restorePointer //save low byte
	lda restorePointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta restorePointer+1 //save high byte
	
//so level pointer
	lda levelPointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 30 to ac-r
	sta levelPointer //save low byte
	lda levelPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta levelPointer+1 //save high byte
//so color pointer	
	lda colorPointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 40 to ac-r
	sta colorPointer //save low byte
	lda colorPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta colorPointer+1 //save high byte
//so screen pointer	
	lda screenPointer //load to a low byte from 251
	clc //clear carry flag
	adc #1 //add 40 to ac-r
	sta screenPointer //save low byte
	lda screenPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta screenPointer+1 //save high byte
	
	rts
	
	
stepPointersDown:

//so color pointer	
	lda colorPointer //load to a low byte from 251
	clc //clear carry flag
	adc #40-12 //add 40 to ac-r
	sta colorPointer //save low byte
	lda colorPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta colorPointer+1 //save high byte
//so screen pointer	
	lda screenPointer //load to a low byte from 251
	clc //clear carry flag
	adc #40-12 //add 40 to ac-r
	sta screenPointer //save low byte
	lda screenPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta screenPointer+1 //save high byte
	
	rts
	
stepPointersDelta:

//so color pointer	
	lda colorPointer //load to a low byte from 251
	clc //clear carry flag
	adc delta //add 40 to ac-r
	sta colorPointer //save low byte
	lda colorPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta colorPointer+1 //save high byte
//so screen pointer	
	lda screenPointer //load to a low byte from 251
	clc //clear carry flag
	adc delta //add 40 to ac-r
	sta screenPointer //save low byte
	lda screenPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta screenPointer+1 //save high byte
	
	rts

	//redraw level from level pointer
redrawLevel:
	lda levelStart //low byte screen start
	sta levelPointer //save low byte
	lda levelStart+1 //high byte screen start
	sta levelPointer+1 //hi byte save	

	
	.for (var j=0;j<=24;j++) 
	{			
	ldy #00		
	.for (var i=0;i<=11;i++) 
			{
				lda (levelPointer),y //5t get character (grab from level pointer)	
				sta screenStart+i+j*40 //4
				tax						//2
				lda tilesColors,x		//4
				sta colorStart+i+j*40	//4
				//skip iny on last
				.if (i<11)
					{
						iny				//2
					}
			}
		
	//CAN BY OPTIMIZED WITH SPLIT BY 3 256 reads or 4 12*21	
	//step level pointer down
	//so level pointer
	
	lda levelPointer //load to a low byte from 251
	clc //clear carry flag
	adc #12 //add 30 to ac-r
	sta levelPointer //save low byte
	lda levelPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta levelPointer+1 //save high byte
	
			
	}
	
	
	rts
	
scrollMapUp:
	
//so color pointer	
	lda levelStart //load to a low byte from 251
	clc //clear carry flag
	adc #12 //add 40 to ac-r
	sta levelStart //save low byte
	lda levelStart+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta levelStart+1 //save high byte	
	
	rts
	
scrollMapDown:	
	//so color pointer	
	
	lda levelStart //load to a low byte from 251
	clc //clear carry flag
	sbc #11 //add 40 to ac-r
	sta levelStart //save low byte
	lda levelStart+1 //load high byte
	sbc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta levelStart+1 //save high byte	
	
	rts
	
levels:	
	.word level00
	.word level02,level01,level03,level04,level06
	.word level08,level09,level07,level10,level05
	.word level11,level24,level25,level22,level12
	.word level15,level21,level14,level13,level23
	.word levelOutro



unpackLevel:

	lda currentLevel
	asl //x2 since word get 2 bytes
	tay
	
	lda levels,y; sta lzsa_src+1;	iny;	lda levels,y; sta lzsa_src+2
//lzsa_dst+1 - where unpack
//lzsa_src+1 - from
	//lda #<level01 sta lzsa_src+1 lda #>level01 sta lzsa_src+2
	lda #<level; sta lzsa_dst+1; lda #>level; sta lzsa_dst+2
	jsr decompress_lzsa1_fast
	rts
