/* MENU */

//deltas for camera and other

//20 deltas
//.align $100 
deltas: .fill $100, 16.5 + 16.5*cos(toRadians(i*360)/256)

//.byte 0,1,2,3,4,5,6,7,7,7,7
counter: .byte 0
yScroll2: .byte 0

pushFireCounter: .byte 0

doDeltas:

	inc pushFireCounter
	lda pushFireCounter
	and #%00001111
	sta pushFireCounter
	
	//inc yScroll
	//lda yScroll
	//and #%00000111	
	//sta yScroll
	inc counter	
	inc counter
	inc counter	
	inc counter
	inc counter	
	//inc counter
	
	lda counter
	tax
	
	lda deltas,x
	lsr 
	sta yScroll2
	lsr 
	
	lsr
	sta yScroll
	
	lda #07; sec; sbc yScroll2; sta yScroll2
	
	//sta heroY
	
	rts

showMenu:
	
	ldx #10; jsr pauseWait	
	
	
	
	//Init VIC IRQ
	jsr initMenuIRQ	
	
	lda #00; sta currentLevel; jsr initLevel; sta counter
	
	//set multicolors for sprites
	lda #12; sta mcSprites0
	lda #15; sta mcSprites1
	
	jsr waitScanline //wait for scanline				
	jsr showScreen
menuLoop:
	
	jsr processCamera	
	jsr waitScanline //wait for scanline				
	
	jsr doKeyboard
	lda firekb
	cmp #01
	beq startPushed
	
	jsr readJoy	
	bcc startPushed
	//lda heroY
	
	
	
	jsr redrawLevel
	jsr copySkyTile	
	
	//dec $d020
	jsr processCamera	
	jsr waitScanline //wait for scanline				
	jsr doAnimationsMenu
	jsr redrawLevel
	jsr copySkyTile	
	
	//jsr animateCoins	
		
	
	jmp menuLoop

startPushed:		
	jmp startGame
	rts	
	
outroTitle:

	//this kills a moon
	lda #%11111111; sta mcModes
	lda #68+25*0+6; sta sprite0X; lda #100; sec; sbc yScroll; sta sprite0Y; lda #1; sta sprite0Color; lda #144+68; sta sprite0
	lda #68+25*1+6; sta sprite1X; lda #100; clc; adc yScroll2; sta sprite1Y; lda #1; sta sprite1Color; lda #144+69; sta sprite1
	lda #68+25*2+6; sta sprite2X; lda #100; sec; sbc yScroll2; sta sprite2Y; lda #1; sta sprite2Color; lda #144+70; sta sprite2	
	lda #68+25*3+6; sta sprite3X; lda #100; clc; adc yScroll2; sta sprite3Y; lda #1; sta sprite3Color; lda #144+71; sta sprite3
	
	lda #%00000000 	
	//x strech same sprites
	sta spriteStretchX
	sta spriteStretchY	
	sta spritesBgPriority
	
	
	lda #68+25*5; sta sprite4X; lda #100; clc; adc yScroll2; sta sprite4Y; lda #1; sta sprite4Color; lda #144+72; sta sprite4
	lda #68+25*6; sta sprite5X; lda #100; sec; sbc yScroll2; sta sprite5Y; lda #1; sta sprite5Color; lda #144+73; sta sprite5
	
	
	lda spritesXbit
	lda #%10000000  	// set extra bit for sprite #6
	sta spritesXbit       // write X-MSB register	
	
	lda #68+25*7; sta sprite6X; lda #100; clc; adc yScroll2; sta sprite6Y; lda #1; sta sprite6Color; lda #144+74; sta sprite6	
	lda #12; sta sprite7X; lda #100; sec; sbc yScroll; sta sprite7Y; lda #1; sta sprite7Color; lda #144+75; sta sprite7


	jmp endSprites
		
menuTitle:
	//enable multicolor sprites and setup all sprites for tittle
	//this kills a moon
	lda #%11111111; sta mcModes
	lda #68+25*0+6; sta sprite0X; lda #100; sec; sbc yScroll2; sta sprite0Y; lda #1; sta sprite0Color; lda #144+54; sta sprite0
	lda #68+25*1+6; sta sprite1X; lda #100; sec; sbc yScroll2; sta sprite1Y; lda #1; sta sprite1Color; lda #144+55; sta sprite1
	lda #68+25*2+6; sta sprite2X; lda #100; sec; sbc yScroll2; sta sprite2Y; lda #1; sta sprite2Color; lda #144+56; sta sprite2	
	
	lda #%00000000 	
	//x strech same sprites
	sta spriteStretchX
	sta spriteStretchY	
	sta spritesBgPriority
	
	lda #68+25*4; sta sprite3X; lda #100; sec; sbc yScroll2; sta sprite3Y; lda #1; sta sprite3Color; lda #144+57; sta sprite3
	lda #68+25*5; sta sprite4X; lda #100; sec; sbc yScroll2; sta sprite4Y; lda #1; sta sprite4Color; lda #144+58; sta sprite4
	lda #68+25*6; sta sprite5X; lda #100; sec; sbc yScroll2; sta sprite5Y; lda #1; sta sprite5Color; lda #144+59; sta sprite5
	
	
	lda spritesXbit
	lda #%10000000  	// set extra bit for sprite #6
	sta spritesXbit       // write X-MSB register	
	
	lda #68+25*7; sta sprite6X; lda #100; sec; sbc yScroll2; sta sprite6Y; lda #1; sta sprite6Color; lda #144+60; sta sprite6	
	lda #12; sta sprite7X; lda #100; sec; sbc yScroll2; sta sprite7Y; lda #1; sta sprite7Color; lda #144+61; sta sprite7
	jmp endSprites		
	
//draw logo 8 sprites
menuIrq0:
	pha	
	stx m0x+1
	sty m0y+1
	
	jsr doDeltas
	
	lda gameState
	cmp #GS_MENU
	bne outroSprites
	jmp menuTitle
outroSprites:	
	jmp outroTitle
	
endSprites:
	
	//dec $d020
	
	lda $d011
	and #%11111000 //low 3 bits
	clc
	adc yScroll
	sta $d011
	
	jsr doStarsMenu
	//jsr $e003
		
	
	//move to irq1 to rearange push fire sprites and sky
	lda #144;  sta $d012	
	lda #<menuIrq1  //;this is how we set up
	sta $fffe  //;the address of our interrupt code
	lda #>menuIrq1
	sta $ffff
	
	lsr $d019 //for correct exit from irq	
	
	pla
m0x: ldx #00
m0y: ldy #00	
	rti
	
//multiplex sprite for push fire
//0,1,2,7 sprites
showTitle:

	rts

menuIrq1:		
	pha	
	stx m1x+1; sty m1y+1

	
	jsr $e003	
	
	//PUSH START
	//disable mcolor sprites mode
	lda #%10000111; sta mcModes	
	//not draw on outro
	lda gameState
	cmp #GS_OUTRO
	beq skipRZ
	//PUSH FIRE
	lda pushFireCounter
	cmp #04
	bcc skipRZ
	lda #65+24*3-8; clc; adc yScroll2; sta sprite0X; lda #190; sta sprite0Y; lda #1; sta sprite0Color; lda #144+62; sta sprite0
	lda #65+24*4-8; clc; adc yScroll2; sta sprite1X; lda #190; sta sprite1Y; lda #1; sta sprite1Color; lda #144+63; sta sprite1
	lda #65+24*5+8; sec; sbc yScroll2; sta sprite2X; lda #190; sta sprite2Y; lda #1; sta sprite2Color; lda #144+64; sta sprite2	
	lda #65+24*6+8; sec; sbc yScroll2; sta sprite7X; lda #190; sta sprite7Y; lda #1; sta sprite7Color; lda #144+65; sta sprite7	
skipRZ:	
	lda spritesXbit
	lda #%00000000  	// set extra bit for sprite #6
	sta spritesXbit       // write X-MSB register
skrop:	
	
		
	jsr initSky
	jsr doSkyMenu
	
	
	//dec $d020
	//move to irq0
	lda #00;  sta $d012	
	lda #<menuIrq0  //;this is how we set up
	sta $fffe  //;the address of our interrupt code
	lda #>menuIrq0
	sta $ffff
	
	lsr $d019 //for correct exit from irq	
	
	pla
	
m1x: ldx #00
m1y: ldy #00

	rti
	
