/* trail */


initTrail:
	lda #<trail //low byte
	sta trailStart //save low byte
	sta trailPointer //save low byte
	lda #>trail //high byte
	sta trailStart+1 //hi byte save	
	sta trailPointer+1 //save low byte
	
//	lda #01 sta xorTrailTicker
		
	//disable all trail
	
	lda #00
	sta trail
	sta trail+5*1
	sta trail+5*2
	sta trail+5*3
	sta trail+5*4
	sta trail+5*5
	sta trail+5*6
	sta trail+5*7
	sta trail+5*8
	sta trail+5*9
	sta trail+5*10
	sta trail+5*11
	
	
	
	rts

//add trail to list
//x,y - position to add trail
// a - frame to add
addTrail:
	sty stackY//save y coord
	pha //save frame
	//count 5
	ldy #0
	lda (trailPointer),y//get count
	cmp #255
	bne at1
	//ok, end of list, switch to start	
	lda #<trail; sta trailPointer; lda #>trail; sta trailPointer+1
at1:
	//new count
	lda #09; sta (trailPointer),y
	//frame
	iny; pla; sta (trailPointer),y
	//new x
	iny; txa; sta (trailPointer),y
	//new y
	iny; lda stackY; sta (trailPointer),y
	//need add tile to restore
	iny
tileToRestore:	lda #00
    sta (trailPointer),y
	
	//Step trail pointer forward
	lda trailPointer //load to a low byte from 251
	clc //clear carry flag
	adc #05 //add 40 to ac-r
	sta trailPointer //save low byte
	lda trailPointer+1 //load high byte
	adc #0  //add 0 with cary if cary set after prev adc that add hi byte
	sta trailPointer+1 //save high byte	
	
	rts	
	
doTrail:
	//xor ticker for trail delay
//	lda xorTrailTicker eor #%00000001 sta xorTrailTicker

  	ldy #00 //reset y 	
  	ldx #12 //trail count
doNextTrailPart:
	sty stackY //save displacement
	stx stackX //save counter
		
	lda (trailStart),y//get count
	cmp #00
	beq dtSkip
	//decrement count with delay
	
	tax; dex; txa; sta (trailStart),y	

	//is it a end of frames - so put a restore block
	cmp #00
	bne dtSkip2
	
	iny; iny; iny; iny 
	lda (trailStart),y//get restore tile
	sta tileTrail+1
	dey; dey; dey
	
	//iny 
	
	jmp dtSkip3
dtSkip2:	
	
	iny//frame
	lda (trailStart),y; sta tileTrail+1
	
dtSkip3:
	//decrement frame
	tax; dex; txa; sta (trailStart),y	
	
	iny//x
	lda (trailStart),y; pha
	iny//y
	lda (trailStart),y
	tay
	pla; tax
	
tileTrail: lda #$00

	jsr putTile
	
dtSkip:
	//to the next
	ldy stackY; tya; clc; adc #05; tay
	ldx stackX; dex
	cpx #00
	bne doNextTrailPart

	rts

/*

UP = 44
DOWN = 48
RIGHT = 52
LEFT = 56
*/
	
trail:

//trail structure - 10 parts
//count,frame,x,y,restoreTile
.byte 0,44,6,60,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,0,0,0,0
.byte 0,43,6,61,0
//end of trail marker
.byte 255
