
.const music = $e000

/*	

	(+) world tile switch
	(+) canons interval based on world	
	(+) fix stand on friend bug		
	(+) too fast fire and fx still on screen		

*/
.var totalTiles = 96
.var getin = $ffe4
.var startLevel = 1

.const screen = 1024
.const colorRam = 55296
.const screenStart = screen+14
.const colorStart = 55296+14

.const restoreBuffer = 2048 //768 bytes
//restoreBuffer: .fill 768, 0
.const level = 2048+768 //768 bytes
//level: .import binary "levels\level01.bin"

//include zero page variables
.import source "include\zeroPage.asm" 

:BasicUpstart2(start)

//.pc = $e000 "Music"
//Playroutine & music data
//music: .import binary "music\music.bin"           

.pc = $1000 "LEVELS 1-21"

start:
	jsr hideScreen
	jsr showIntroText
 	jsr hideScreen 	
 	jsr showIntro
 	jmp totalStart

level01: .import binary "levels\level01.lz"
level02: .import binary "levels\level02.lz"
level03: .import binary "levels\level03.lz"
level04: .import binary "levels\level04.lz"
level05: .import binary "levels\level05.lz"
level06: .import binary "levels\level06.lz"
level07: .import binary "levels\level07.lz"
level08: .import binary "levels\level08.lz"
level09: .import binary "levels\level09.lz"
level10: .import binary "levels\level10.lz"
level11: .import binary "levels\level11.lz"
level12: .import binary "levels\level12.lz"
level13: .import binary "levels\level13.lz"
level14: .import binary "levels\level14.lz"
level15: .import binary "levels\level15.lz"
level21: .import binary "levels\level21.lz"

//.var music = LoadSid("music\dm.sid")
//	.fill music.size, music.getData(i)
.pc =  $2000 "Tiles&gfx&levelbuffer"
//tiles
tiles: .import binary "gfx\tiles.bin"
.fill 24,0

tilesColors: .import binary "gfx\colors.bin"
coins:  .import binary "gfx\coins.bin"

.pc = $2400 "Sprites"
sprites:  .import binary "gfx\sprites.bin"
//from 53
skySprites:     .import binary "gfx\sky.bin"
logoSprites: .import binary "gfx\logo.bin"
pfSprites: .import binary "gfx\pushfire.bin"
wdSprites: .import binary "gfx\welldone.bin"



//.align 64
//sprites:  .import binary "gfx\sprites.bin"

//levels and data
//.pc = $4000 "Game,Levels Data & sounds"
//.pc = "Game,Levels Data & sounds"
	.import source "include\system.asm" 
	.import source "include\interrupt.asm" 
	.import source "include\sprites.asm" 
	.import source "include\camera.asm" 
	.import source "include\input.asm" 
	.import source "include\animations.asm" 	
	.import source "include\lzsa.asm" 	
	.import source "include\intro.asm" 

	level00: .import binary "levels\menu.lz"	
level22: .import binary "levels\level22.lz"
level23: .import binary "levels\level23.lz"
level24: .import binary "levels\level24.lz"
level25: .import binary "levels\level25.lz"
levelOutro: .import binary "levels\outro.lz"

tiles02: .import binary "gfx\tiles02.bin"
tilesColors02: .import binary "gfx\colors02.bin"

tiles03: .import binary "gfx\tiles03.bin"
tilesColors03: .import binary "gfx\colors03.bin"		
	
.pc = $6000 "PIX" 	
.import binary "gfx\mcPic.kla",2

/*	
.pc = 16384+8192-2048 "Color RAM" 
	.import binary "gfx\mcPic.kla",9002,1000
picBG:	.import binary "gfx\mcPic.kla",10002,1
//screen ram
.pc = 16384+8192-1024 "Screen RAM"
	.import binary "gfx\mcPic.kla",8002,1000
	
.pc = 16384+8192 "BITMAP"	
	//.fill 8000,0
mcPic: .import binary "gfx\mcPic.kla",2,8000
*/
	
.pc = * "REST CODE"				
//.pc = 32768 "REST CODE"	
	.import source "include\hero.asm" 
	.import source "include\tiles.asm" 
	.import source "include\trail.asm" 
	.import source "include\fx.asm" 
	.import source "include\guns.asm" 	
	.import source "include\enemies.asm" 
	.import source "include\sky.asm" 
	.import source "include\sound.asm" 
	.import source "include\menu.asm" 
	.import source "include\outro.asm" 	
	.import source "include\level.asm" 		

	


totalStart:
	
	lda #00 
	sta frameReady
	
	jsr initScreen									
	jsr drawTower					
	//Init VIC
	//jsr initIRQ	
	
	lda #GS_MENU
	sta gameState
	jmp showMenu
//	lda #GS_OUTRO sta gameState
	//jmp showOutro
		
startGame:

	

	lda #1 ; sta currentMusic ; jsr $e000                       //Initialize subtune 0 	
	ldx #4 ; jsr pauseWait

	lda #GS_GAMEPLAY
	sta gameState
	
	
 	jsr hideScreen	
 	 	
 	
 	lda #05
 	jsr playSound 	
 	ldx #10 ; jsr pauseWait
 	
 	
 	
 	jsr initIRQ	//init gameplay IRQ		
	lda #startLevel ; sta currentLevel
	
	//lda #14 sta $d021
restartLevel:
	jsr hideScreen
	ldx #4 ; jsr pauseWait	
	
	lda currentLevel
	cmp #21
	bne notOutro
	lda #GS_OUTRO ; sta gameState
	jmp showOutro
notOutro:
	
	
	jsr resetVICSprites		
	jsr initLevel	
	//jsr doHero
	//jsr doFX
	//jsr doHero
	lda #144+51 ; sta sprite0
	lda #144+51 ; sta sprite1	
	ldx #4 ; jsr pauseWait
	
	
	
	
	
	jsr showScreen

		
mainLoop:   
	lda gameState
	cmp #GS_GAMEPLAY
	beq doGameplay
	cmp #GS_CLEAR
	beq doStageClear	
	jmp mainLoop
	
doStageClear:	
	//if clear count > 40	
	lda clearCount
	cmp #32
	beq ready
	inc clearCount
	jmp gameplay
ready:	

	inc pushFireCounter
	lda pushFireCounter
	and #%00000111
	sta pushFireCounter
	
	//PUSH FIRE
	lda pushFireCounter
	cmp #04
	bcc skipPF
	//replace hero and fx sprite with push fire sprite
	lda #144+66 ; sta sprite0
	lda #160-2 ; sta sprite0X ; lda# 224 ; sta sprite0Y//50
	lda #144+67 ; sta sprite1
	lda #160+28-2 ; sta sprite1X ; lda# 224 ; sta sprite1Y		
	bcs skipPF2
skipPF:	
	lda# 255 ; sta sprite0Y
	lda# 255 ; sta sprite1Y	
skipPF2:
	
	//check if we hit a fire then switch level
	
	jsr doKeyboard
	lda firekb
	cmp #01
	beq fireFire
	
	jsr readJoy	
	//check fire
	bcs doGameplay
fireFire:	
	lda #24 ; sta fireDelay		
	//switch
	lda isDead
	bne wasDead
	inc currentLevel
wasDead:	
	lda #GS_GAMEPLAY ; sta gameState
	lda #05 ; jsr playSound 	
	//jsr initLevel
	jmp restartLevel
	
doGameplay:	
	jmp gameplay
	

	
stageClear:
	
//	jmp mainLoop	
	
gameplay:

	//jmp mainLoop
	jsr processCamera		
	//jsr doKeyboard
	:SetBorderColor(0)
	jsr waitScanline //wait for scanline		
	//:SetBorderColor(2)			
	//jsr processCamera		
	
	/*												
	lda $d011
	and #%11111000 //low 3 bits
	clc
	adc yScroll
	sta $d011
	*/		
	//:SetBorderColor(1)	
	//jsr doSky		
	jsr redrawLevel	
	jsr copySkyTile	
	jsr animateExit
	
	
	jsr doHero	
	jsr doEnemies
	jsr doFX	
	
	
	
	jsr processCamera	
	//jsr doKeyboard	
	
	:SetBorderColor(0)
	jsr waitScanline //wait for scanline	
	//:SetBorderColor(2)		
			
	jsr doGuns
	jsr redrawLevel	
	jsr copySkyTile
	jsr doAnimations		
	jsr animateExit
	
					
	jmp mainLoop
		
pauseWait:	
	
sPause: 	
 	jsr waitScanlineEx
 	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop
 	dex
 	cpx #00
 	bne sPause
 	rts
 

 	
musicPacked: .import binary "music\music.lz"            	
musicPackedNTSC: .import binary "music\musicNTSC.lz"            	
 		
//include system functions
	
		
//level: .import binary "levels\test.bin"
//level: .import binary "levels\level05.bin"

//introPixels: .import binary "gfx\pixels.lz"
//introColors: .import binary "gfx\colors.lz"
//levelColors:	 .fill 768,0
//.pc = 32768+10003 "packedLevels etc"

//.pc = 32768+8192 "intro image"
//mcPic: .import binary "gfx\mcPic.kla"


//.pc = 49152+8192 "packedLevels etc"
//.pc = 32768+8192-1023 "zzz"
//picColor: .import binary "gfx\intro.art", $2
//.pc = 32768+8192 "1"
//picScreen: .import binary "gfx\intro.art", 2, 8000


//---------------------------------------------------------
//* = music.location "Music"
 	//.fill music.size, music.getData(i)
//----------------------------------------------------------
// Print the music info while assembling
/*
.print ""
.print "SID Data"
.print "--------"
.print "location=$"+toHexString(music.location)
.print "init=$"+toHexString(music.init)
.print "play=$"+toHexString(music.play)
.print "songs="+music.songs
.print "startSong="+music.startSong
.print "size=$"+toHexString(music.size)
.print "name="+music.name
.print "author="+music.author
.print "copyright="+music.copyright
.print ""
.print "Additional tech data"
.print "--------------------"
.print "header="+music.header
.print "header version="+music.version
.print "flags="+toBinaryString(music.flags)
.print "speed="+toBinaryString(music.speed)
.print "startpage="+music.startpage
.print "pagelength="+music.pagelength
*/